using System;
using System.Collections.Generic;
using System.Text;

namespace TcpClientTester
{
    public static class ByteArrayUtil
    {
        /// <summary>
        /// oCg^z񒆂̎woCgAwrbg̒lbool^Ŏ擾
        /// </summary>
        /// <param name="tmpByte"></param>
        /// <param name="iByteNum"></param>
        /// <param name="iBitNum"></param>
        /// <returns></returns>
        public static bool GetBitByByteArray(Byte[] tmpByte, int iByteNum, int iBitNum)
        {
            bool bResult = false;   // ߂l
            String sCompStr;        // 2i`̕ɕϊꂽoCgli[

            // nl`FbN
            if ((iByteNum < 0)
                || (iBitNum < 0)
                || (iBitNum > 7)
                || (tmpByte.Length + 1 < iByteNum)) { throw new OverflowException(); }

            // nl̃oCgz񒆂̎woCgA2iɕϊB
            sCompStr = "00000000" + Convert.ToString(tmpByte[iByteNum], 2);
            sCompStr = sCompStr.Substring(sCompStr.Length - 8);

            // w肳ꂽrbgu1v̂ƂTrue, iu0v̂ƂFalsejԂB
            if (sCompStr[7 - iBitNum] == '1') { bResult = true; }

            return bResult;
        }

        /// <summary>
        /// oCg^z̎woCgAwrbgAnlɕύXB
        /// </summary>
        /// <param name="tmpByte"></param>
        /// <param name="iByteNum"></param>
        /// <param name="iBitNum"></param>
        /// <param name="bValue"></param>
        public static void SetBitToByteArray(Byte[] tmpByte, int iByteNum, int iBitNum, bool bValue)
        {
            String sCompStr;        // 2i`̕ɕϊꂽoCgli[
            String sSetStr;         // XVlێ

            // nl`FbN
            if ((iByteNum < 0)
                || (iBitNum < 0)
                || (iBitNum > 7)
                || (tmpByte.Length + 1 < iByteNum)) { throw new OverflowException(); }

            // nl̃oCgz񒆂̎woCgA2iɕϊB
            sCompStr = "00000000" + Convert.ToString(tmpByte[iByteNum], 2);
            sCompStr = sCompStr.Substring(sCompStr.Length - 8);

            //@wrbĝ݂Anlboollɕϊ2iB
            sSetStr = "";
            for (int i = 0; i <= 7; i++)
            {
                if ((7 - iBitNum) == i)
                {
                    if (bValue) { sSetStr += "1"; } else { sSetStr += "0"; }
                }
                else
                {
                    sSetStr += sCompStr[i];
                }
            }

            // Cς݂2ioCg^ɕϊAnloCgz̎woCgƍւB
            tmpByte[iByteNum] = (byte)Convert.ToInt16(sSetStr, 2);
        }


        /// <summary>
        /// oCg^z̎wJnoCgAIoCg؂oāA
        /// 10iɕϊB
        /// </summary>
        /// <param name="tmpByte"></param>
        /// <param name="iStartNum"></param>
        /// <param name="iCloseNum"></param>
        /// <returns></returns>
        public static Int32 GetIntByByteArray(Byte[] tmpByte, int iStartNum, int iCloseNum)
        {
            Int32 iReslut = 0;  // ߂l
            Byte[] bIntBytes = new Byte[4];   // lϊpoCgz

            // nl`FbN
            if (
                    (iStartNum < 0)
                    || (iCloseNum < 0)
                    || (tmpByte.Length + 1 < iStartNum)
                    || (tmpByte.Length + 1 < iCloseNum)
                    || (iStartNum > iCloseNum)
                    || ((iCloseNum - iStartNum) > 4)
                ) { throw new OverflowException(); }

            //JnʒuEIʒuŎw肳ꂽz񕪂oA
            //lϊpoCgzɃZbgB;
            for (int i = iStartNum; i <= iCloseNum; i++)
            {
                //bIntBytes[i - iStartNum] = tmpByte[i];
                bIntBytes[(iCloseNum - iStartNum) - (i - iStartNum)] = tmpByte[i];
            }

            // oCgz10iɕϊ
            iReslut = BitConverter.ToInt32(bIntBytes, 0);

            return iReslut;
        }

        /// <summary>
        /// nl̐oCgz񉻂Anl̃oCgz񒆂̎woCg͈͂ւB
        /// </summary>
        /// <param name="rcvByte"></param>
        /// <param name="iStartNum"></param>
        /// <param name="iCloseNum"></param>
        /// <param name="iValue"></param>
        public static void SetIntToByteArray(Byte[] rcvByte, int iStartNum, int iCloseNum, Int32 iValue)
        {
            // nl`FbN
            if (
                    (iStartNum < 0)
                    || (iCloseNum < 0)
                    || (rcvByte.Length + 1 < iStartNum)
                    || (rcvByte.Length + 1 < iCloseNum)
                    || (iStartNum > iCloseNum)
                    || ((iCloseNum - iStartNum) > 4)
                ) { throw new OverflowException(); }

            // oCgz̎wӏ
            for (int i = iStartNum; i <= iCloseNum; i++) { rcvByte[i] = 0; }

            // nl̐AoCgz񉻂B
            // Int32^œn̂ŁA4oCg̃gEGfBAzɂȂB
            byte[] tmpByte = BitConverter.GetBytes(iValue);

            // oCgz̎wӏɁAϊoCgzRs[B
            // nlŎw͈͂ArbOEGfBȀɕёւăRs[B
            for (int i = iStartNum; i <= iCloseNum; i++)
            {
                rcvByte[i] = tmpByte[(iCloseNum - iStartNum) - (i - iStartNum)];
            }

        }

        /// <summary>
        /// oCgz̃f[^16iŕԂB
        /// </summary>
        /// <param name="rcvByte"></param>
        /// <param name="iStartNum"></param>
        /// <param name="iCloseNum"></param>
        /// <returns></returns>
        public static string GetHexStrByByteArray(byte[] rcvByte, int iStartNum, int iCloseNum)
        {
            string sReslut ="";
            // nl`FbN
            if (
                    (iStartNum < 0)
                    || (iCloseNum < 0)
                    || (rcvByte.Length + 1 < iStartNum)
                    || (rcvByte.Length + 1 < iCloseNum)
                    || (iStartNum > iCloseNum)
                ) { throw new OverflowException(); }

            for (int i = iStartNum; i <= iCloseNum; i++)
            {
                sReslut += rcvByte[i].ToString("x2");
                if (i != iCloseNum) { sReslut += "-"; }
            }
            return sReslut;
        }

        /// <summary>
        /// 16i1oCgAoCg^ŕԂB
        /// </summary>
        /// <param name="hexStr"></param>
        /// <returns></returns>
        public static byte GetByteByHexStr(string hexStr)
        {
            short iTmpNum;
            try
            {
                iTmpNum = Convert.ToInt16(hexStr, 16);
            }
            catch
            {
                iTmpNum = 0;
            }
            return (byte)iTmpNum;
        }
    }
}
